<a id="mypy-boto3-redshift"></a>

# mypy-boto3-redshift

[![PyPI - mypy-boto3-redshift](https://img.shields.io/pypi/v/mypy-boto3-redshift.svg?color=blue)](https://pypi.org/project/mypy-boto3-redshift)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-redshift.svg?color=blue)](https://pypi.org/project/mypy-boto3-redshift)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-redshift?color=blue)](https://pypistats.org/packages/mypy-boto3-redshift)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Redshift 1.21.34](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/redshift.html#Redshift)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.5.8](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-redshift docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_redshift/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-redshift](#mypy-boto3-redshift)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Redshift`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `Redshift` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[redshift]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[redshift]'


# standalone installation
python -m pip install mypy-boto3-redshift
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-redshift
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[redshift]` in your environment:

```bash
python -m pip install 'boto3-stubs[redshift]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[redshift]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[redshift]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[redshift]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[redshift]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[redshift]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[redshift]` in your environment:

```bash
python -m pip install 'boto3-stubs[redshift]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[redshift]` in your environment:

```bash
python -m pip install 'boto3-stubs[redshift]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`RedshiftClient` provides annotations for `boto3.client("redshift")`.

```python
from boto3.session import Session

from mypy_boto3_redshift import RedshiftClient

client: RedshiftClient = Session().client("redshift")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_redshift.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_redshift import RedshiftClient
from mypy_boto3_redshift.paginator import (
    DescribeClusterDbRevisionsPaginator,
    DescribeClusterParameterGroupsPaginator,
    DescribeClusterParametersPaginator,
    DescribeClusterSecurityGroupsPaginator,
    DescribeClusterSnapshotsPaginator,
    DescribeClusterSubnetGroupsPaginator,
    DescribeClusterTracksPaginator,
    DescribeClusterVersionsPaginator,
    DescribeClustersPaginator,
    DescribeDataSharesPaginator,
    DescribeDataSharesForConsumerPaginator,
    DescribeDataSharesForProducerPaginator,
    DescribeDefaultClusterParametersPaginator,
    DescribeEndpointAccessPaginator,
    DescribeEndpointAuthorizationPaginator,
    DescribeEventSubscriptionsPaginator,
    DescribeEventsPaginator,
    DescribeHsmClientCertificatesPaginator,
    DescribeHsmConfigurationsPaginator,
    DescribeNodeConfigurationOptionsPaginator,
    DescribeOrderableClusterOptionsPaginator,
    DescribeReservedNodeExchangeStatusPaginator,
    DescribeReservedNodeOfferingsPaginator,
    DescribeReservedNodesPaginator,
    DescribeScheduledActionsPaginator,
    DescribeSnapshotCopyGrantsPaginator,
    DescribeSnapshotSchedulesPaginator,
    DescribeTableRestoreStatusPaginator,
    DescribeTagsPaginator,
    DescribeUsageLimitsPaginator,
    GetReservedNodeExchangeConfigurationOptionsPaginator,
    GetReservedNodeExchangeOfferingsPaginator,
)

client: RedshiftClient = Session().client("redshift")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_cluster_db_revisions_paginator: DescribeClusterDbRevisionsPaginator = client.get_paginator("describe_cluster_db_revisions")
describe_cluster_parameter_groups_paginator: DescribeClusterParameterGroupsPaginator = client.get_paginator("describe_cluster_parameter_groups")
describe_cluster_parameters_paginator: DescribeClusterParametersPaginator = client.get_paginator("describe_cluster_parameters")
describe_cluster_security_groups_paginator: DescribeClusterSecurityGroupsPaginator = client.get_paginator("describe_cluster_security_groups")
describe_cluster_snapshots_paginator: DescribeClusterSnapshotsPaginator = client.get_paginator("describe_cluster_snapshots")
describe_cluster_subnet_groups_paginator: DescribeClusterSubnetGroupsPaginator = client.get_paginator("describe_cluster_subnet_groups")
describe_cluster_tracks_paginator: DescribeClusterTracksPaginator = client.get_paginator("describe_cluster_tracks")
describe_cluster_versions_paginator: DescribeClusterVersionsPaginator = client.get_paginator("describe_cluster_versions")
describe_clusters_paginator: DescribeClustersPaginator = client.get_paginator("describe_clusters")
describe_data_shares_paginator: DescribeDataSharesPaginator = client.get_paginator("describe_data_shares")
describe_data_shares_for_consumer_paginator: DescribeDataSharesForConsumerPaginator = client.get_paginator("describe_data_shares_for_consumer")
describe_data_shares_for_producer_paginator: DescribeDataSharesForProducerPaginator = client.get_paginator("describe_data_shares_for_producer")
describe_default_cluster_parameters_paginator: DescribeDefaultClusterParametersPaginator = client.get_paginator("describe_default_cluster_parameters")
describe_endpoint_access_paginator: DescribeEndpointAccessPaginator = client.get_paginator("describe_endpoint_access")
describe_endpoint_authorization_paginator: DescribeEndpointAuthorizationPaginator = client.get_paginator("describe_endpoint_authorization")
describe_event_subscriptions_paginator: DescribeEventSubscriptionsPaginator = client.get_paginator("describe_event_subscriptions")
describe_events_paginator: DescribeEventsPaginator = client.get_paginator("describe_events")
describe_hsm_client_certificates_paginator: DescribeHsmClientCertificatesPaginator = client.get_paginator("describe_hsm_client_certificates")
describe_hsm_configurations_paginator: DescribeHsmConfigurationsPaginator = client.get_paginator("describe_hsm_configurations")
describe_node_configuration_options_paginator: DescribeNodeConfigurationOptionsPaginator = client.get_paginator("describe_node_configuration_options")
describe_orderable_cluster_options_paginator: DescribeOrderableClusterOptionsPaginator = client.get_paginator("describe_orderable_cluster_options")
describe_reserved_node_exchange_status_paginator: DescribeReservedNodeExchangeStatusPaginator = client.get_paginator("describe_reserved_node_exchange_status")
describe_reserved_node_offerings_paginator: DescribeReservedNodeOfferingsPaginator = client.get_paginator("describe_reserved_node_offerings")
describe_reserved_nodes_paginator: DescribeReservedNodesPaginator = client.get_paginator("describe_reserved_nodes")
describe_scheduled_actions_paginator: DescribeScheduledActionsPaginator = client.get_paginator("describe_scheduled_actions")
describe_snapshot_copy_grants_paginator: DescribeSnapshotCopyGrantsPaginator = client.get_paginator("describe_snapshot_copy_grants")
describe_snapshot_schedules_paginator: DescribeSnapshotSchedulesPaginator = client.get_paginator("describe_snapshot_schedules")
describe_table_restore_status_paginator: DescribeTableRestoreStatusPaginator = client.get_paginator("describe_table_restore_status")
describe_tags_paginator: DescribeTagsPaginator = client.get_paginator("describe_tags")
describe_usage_limits_paginator: DescribeUsageLimitsPaginator = client.get_paginator("describe_usage_limits")
get_reserved_node_exchange_configuration_options_paginator: GetReservedNodeExchangeConfigurationOptionsPaginator = client.get_paginator("get_reserved_node_exchange_configuration_options")
get_reserved_node_exchange_offerings_paginator: GetReservedNodeExchangeOfferingsPaginator = client.get_paginator("get_reserved_node_exchange_offerings")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_redshift.waiter` module contains type annotations for all waiters.

```python
from boto3.session import Session

from mypy_boto3_redshift import RedshiftClient
from mypy_boto3_redshift.waiter import (
    ClusterAvailableWaiter,
    ClusterDeletedWaiter,
    ClusterRestoredWaiter,
    SnapshotAvailableWaiter,
)

client: RedshiftClient = Session().client("redshift")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
cluster_available_waiter: ClusterAvailableWaiter = client.get_waiter("cluster_available")
cluster_deleted_waiter: ClusterDeletedWaiter = client.get_waiter("cluster_deleted")
cluster_restored_waiter: ClusterRestoredWaiter = client.get_waiter("cluster_restored")
snapshot_available_waiter: SnapshotAvailableWaiter = client.get_waiter("snapshot_available")
```

<a id="literals"></a>

### Literals

`mypy_boto3_redshift.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_redshift.literals import (
    ActionTypeType,
    AquaConfigurationStatusType,
    AquaStatusType,
    AuthorizationStatusType,
    ClusterAvailableWaiterName,
    ClusterDeletedWaiterName,
    ClusterRestoredWaiterName,
    DataShareStatusForConsumerType,
    DataShareStatusForProducerType,
    DataShareStatusType,
    DescribeClusterDbRevisionsPaginatorName,
    DescribeClusterParameterGroupsPaginatorName,
    DescribeClusterParametersPaginatorName,
    DescribeClusterSecurityGroupsPaginatorName,
    DescribeClusterSnapshotsPaginatorName,
    DescribeClusterSubnetGroupsPaginatorName,
    DescribeClusterTracksPaginatorName,
    DescribeClusterVersionsPaginatorName,
    DescribeClustersPaginatorName,
    DescribeDataSharesForConsumerPaginatorName,
    DescribeDataSharesForProducerPaginatorName,
    DescribeDataSharesPaginatorName,
    DescribeDefaultClusterParametersPaginatorName,
    DescribeEndpointAccessPaginatorName,
    DescribeEndpointAuthorizationPaginatorName,
    DescribeEventSubscriptionsPaginatorName,
    DescribeEventsPaginatorName,
    DescribeHsmClientCertificatesPaginatorName,
    DescribeHsmConfigurationsPaginatorName,
    DescribeNodeConfigurationOptionsPaginatorName,
    DescribeOrderableClusterOptionsPaginatorName,
    DescribeReservedNodeExchangeStatusPaginatorName,
    DescribeReservedNodeOfferingsPaginatorName,
    DescribeReservedNodesPaginatorName,
    DescribeScheduledActionsPaginatorName,
    DescribeSnapshotCopyGrantsPaginatorName,
    DescribeSnapshotSchedulesPaginatorName,
    DescribeTableRestoreStatusPaginatorName,
    DescribeTagsPaginatorName,
    DescribeUsageLimitsPaginatorName,
    GetReservedNodeExchangeConfigurationOptionsPaginatorName,
    GetReservedNodeExchangeOfferingsPaginatorName,
    ModeType,
    NodeConfigurationOptionsFilterNameType,
    OperatorTypeType,
    ParameterApplyTypeType,
    PartnerIntegrationStatusType,
    ReservedNodeExchangeActionTypeType,
    ReservedNodeExchangeStatusTypeType,
    ReservedNodeOfferingTypeType,
    ScheduleStateType,
    ScheduledActionFilterNameType,
    ScheduledActionStateType,
    ScheduledActionTypeValuesType,
    SnapshotAttributeToSortByType,
    SnapshotAvailableWaiterName,
    SortByOrderType,
    SourceTypeType,
    TableRestoreStatusTypeType,
    UsageLimitBreachActionType,
    UsageLimitFeatureTypeType,
    UsageLimitLimitTypeType,
    UsageLimitPeriodType,
    RedshiftServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)

def check_value(value: ActionTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_redshift.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_redshift.type_defs import (
    AcceptReservedNodeExchangeInputMessageRequestTypeDef,
    AcceptReservedNodeExchangeOutputMessageTypeDef,
    AccountAttributeListTypeDef,
    AccountAttributeTypeDef,
    AccountWithRestoreAccessTypeDef,
    AquaConfigurationTypeDef,
    AssociateDataShareConsumerMessageRequestTypeDef,
    AttributeValueTargetTypeDef,
    AuthenticationProfileTypeDef,
    AuthorizeClusterSecurityGroupIngressMessageRequestTypeDef,
    AuthorizeClusterSecurityGroupIngressResultTypeDef,
    AuthorizeDataShareMessageRequestTypeDef,
    AuthorizeEndpointAccessMessageRequestTypeDef,
    AuthorizeSnapshotAccessMessageRequestTypeDef,
    AuthorizeSnapshotAccessResultTypeDef,
    AvailabilityZoneTypeDef,
    BatchDeleteClusterSnapshotsRequestRequestTypeDef,
    BatchDeleteClusterSnapshotsResultTypeDef,
    BatchModifyClusterSnapshotsMessageRequestTypeDef,
    BatchModifyClusterSnapshotsOutputMessageTypeDef,
    CancelResizeMessageRequestTypeDef,
    ClusterAssociatedToScheduleTypeDef,
    ClusterCredentialsTypeDef,
    ClusterDbRevisionTypeDef,
    ClusterDbRevisionsMessageTypeDef,
    ClusterIamRoleTypeDef,
    ClusterNodeTypeDef,
    ClusterParameterGroupDetailsTypeDef,
    ClusterParameterGroupNameMessageTypeDef,
    ClusterParameterGroupStatusTypeDef,
    ClusterParameterGroupTypeDef,
    ClusterParameterGroupsMessageTypeDef,
    ClusterParameterStatusTypeDef,
    ClusterSecurityGroupMembershipTypeDef,
    ClusterSecurityGroupMessageTypeDef,
    ClusterSecurityGroupTypeDef,
    ClusterSnapshotCopyStatusTypeDef,
    ClusterSubnetGroupMessageTypeDef,
    ClusterSubnetGroupTypeDef,
    ClusterTypeDef,
    ClusterVersionTypeDef,
    ClusterVersionsMessageTypeDef,
    ClustersMessageTypeDef,
    CopyClusterSnapshotMessageRequestTypeDef,
    CopyClusterSnapshotResultTypeDef,
    CreateAuthenticationProfileMessageRequestTypeDef,
    CreateAuthenticationProfileResultTypeDef,
    CreateClusterMessageRequestTypeDef,
    CreateClusterParameterGroupMessageRequestTypeDef,
    CreateClusterParameterGroupResultTypeDef,
    CreateClusterResultTypeDef,
    CreateClusterSecurityGroupMessageRequestTypeDef,
    CreateClusterSecurityGroupResultTypeDef,
    CreateClusterSnapshotMessageRequestTypeDef,
    CreateClusterSnapshotResultTypeDef,
    CreateClusterSubnetGroupMessageRequestTypeDef,
    CreateClusterSubnetGroupResultTypeDef,
    CreateEndpointAccessMessageRequestTypeDef,
    CreateEventSubscriptionMessageRequestTypeDef,
    CreateEventSubscriptionResultTypeDef,
    CreateHsmClientCertificateMessageRequestTypeDef,
    CreateHsmClientCertificateResultTypeDef,
    CreateHsmConfigurationMessageRequestTypeDef,
    CreateHsmConfigurationResultTypeDef,
    CreateScheduledActionMessageRequestTypeDef,
    CreateSnapshotCopyGrantMessageRequestTypeDef,
    CreateSnapshotCopyGrantResultTypeDef,
    CreateSnapshotScheduleMessageRequestTypeDef,
    CreateTagsMessageRequestTypeDef,
    CreateUsageLimitMessageRequestTypeDef,
    CustomerStorageMessageTypeDef,
    DataShareAssociationTypeDef,
    DataShareResponseMetadataTypeDef,
    DataShareTypeDef,
    DataTransferProgressTypeDef,
    DeauthorizeDataShareMessageRequestTypeDef,
    DefaultClusterParametersTypeDef,
    DeferredMaintenanceWindowTypeDef,
    DeleteAuthenticationProfileMessageRequestTypeDef,
    DeleteAuthenticationProfileResultTypeDef,
    DeleteClusterMessageRequestTypeDef,
    DeleteClusterParameterGroupMessageRequestTypeDef,
    DeleteClusterResultTypeDef,
    DeleteClusterSecurityGroupMessageRequestTypeDef,
    DeleteClusterSnapshotMessageRequestTypeDef,
    DeleteClusterSnapshotMessageTypeDef,
    DeleteClusterSnapshotResultTypeDef,
    DeleteClusterSubnetGroupMessageRequestTypeDef,
    DeleteEndpointAccessMessageRequestTypeDef,
    DeleteEventSubscriptionMessageRequestTypeDef,
    DeleteHsmClientCertificateMessageRequestTypeDef,
    DeleteHsmConfigurationMessageRequestTypeDef,
    DeleteScheduledActionMessageRequestTypeDef,
    DeleteSnapshotCopyGrantMessageRequestTypeDef,
    DeleteSnapshotScheduleMessageRequestTypeDef,
    DeleteTagsMessageRequestTypeDef,
    DeleteUsageLimitMessageRequestTypeDef,
    DescribeAccountAttributesMessageRequestTypeDef,
    DescribeAuthenticationProfilesMessageRequestTypeDef,
    DescribeAuthenticationProfilesResultTypeDef,
    DescribeClusterDbRevisionsMessageDescribeClusterDbRevisionsPaginateTypeDef,
    DescribeClusterDbRevisionsMessageRequestTypeDef,
    DescribeClusterParameterGroupsMessageDescribeClusterParameterGroupsPaginateTypeDef,
    DescribeClusterParameterGroupsMessageRequestTypeDef,
    DescribeClusterParametersMessageDescribeClusterParametersPaginateTypeDef,
    DescribeClusterParametersMessageRequestTypeDef,
    DescribeClusterSecurityGroupsMessageDescribeClusterSecurityGroupsPaginateTypeDef,
    DescribeClusterSecurityGroupsMessageRequestTypeDef,
    DescribeClusterSnapshotsMessageDescribeClusterSnapshotsPaginateTypeDef,
    DescribeClusterSnapshotsMessageRequestTypeDef,
    DescribeClusterSnapshotsMessageSnapshotAvailableWaitTypeDef,
    DescribeClusterSubnetGroupsMessageDescribeClusterSubnetGroupsPaginateTypeDef,
    DescribeClusterSubnetGroupsMessageRequestTypeDef,
    DescribeClusterTracksMessageDescribeClusterTracksPaginateTypeDef,
    DescribeClusterTracksMessageRequestTypeDef,
    DescribeClusterVersionsMessageDescribeClusterVersionsPaginateTypeDef,
    DescribeClusterVersionsMessageRequestTypeDef,
    DescribeClustersMessageClusterAvailableWaitTypeDef,
    DescribeClustersMessageClusterDeletedWaitTypeDef,
    DescribeClustersMessageClusterRestoredWaitTypeDef,
    DescribeClustersMessageDescribeClustersPaginateTypeDef,
    DescribeClustersMessageRequestTypeDef,
    DescribeDataSharesForConsumerMessageDescribeDataSharesForConsumerPaginateTypeDef,
    DescribeDataSharesForConsumerMessageRequestTypeDef,
    DescribeDataSharesForConsumerResultTypeDef,
    DescribeDataSharesForProducerMessageDescribeDataSharesForProducerPaginateTypeDef,
    DescribeDataSharesForProducerMessageRequestTypeDef,
    DescribeDataSharesForProducerResultTypeDef,
    DescribeDataSharesMessageDescribeDataSharesPaginateTypeDef,
    DescribeDataSharesMessageRequestTypeDef,
    DescribeDataSharesResultTypeDef,
    DescribeDefaultClusterParametersMessageDescribeDefaultClusterParametersPaginateTypeDef,
    DescribeDefaultClusterParametersMessageRequestTypeDef,
    DescribeDefaultClusterParametersResultTypeDef,
    DescribeEndpointAccessMessageDescribeEndpointAccessPaginateTypeDef,
    DescribeEndpointAccessMessageRequestTypeDef,
    DescribeEndpointAuthorizationMessageDescribeEndpointAuthorizationPaginateTypeDef,
    DescribeEndpointAuthorizationMessageRequestTypeDef,
    DescribeEventCategoriesMessageRequestTypeDef,
    DescribeEventSubscriptionsMessageDescribeEventSubscriptionsPaginateTypeDef,
    DescribeEventSubscriptionsMessageRequestTypeDef,
    DescribeEventsMessageDescribeEventsPaginateTypeDef,
    DescribeEventsMessageRequestTypeDef,
    DescribeHsmClientCertificatesMessageDescribeHsmClientCertificatesPaginateTypeDef,
    DescribeHsmClientCertificatesMessageRequestTypeDef,
    DescribeHsmConfigurationsMessageDescribeHsmConfigurationsPaginateTypeDef,
    DescribeHsmConfigurationsMessageRequestTypeDef,
    DescribeLoggingStatusMessageRequestTypeDef,
    DescribeNodeConfigurationOptionsMessageDescribeNodeConfigurationOptionsPaginateTypeDef,
    DescribeNodeConfigurationOptionsMessageRequestTypeDef,
    DescribeOrderableClusterOptionsMessageDescribeOrderableClusterOptionsPaginateTypeDef,
    DescribeOrderableClusterOptionsMessageRequestTypeDef,
    DescribePartnersInputMessageRequestTypeDef,
    DescribePartnersOutputMessageTypeDef,
    DescribeReservedNodeExchangeStatusInputMessageDescribeReservedNodeExchangeStatusPaginateTypeDef,
    DescribeReservedNodeExchangeStatusInputMessageRequestTypeDef,
    DescribeReservedNodeExchangeStatusOutputMessageTypeDef,
    DescribeReservedNodeOfferingsMessageDescribeReservedNodeOfferingsPaginateTypeDef,
    DescribeReservedNodeOfferingsMessageRequestTypeDef,
    DescribeReservedNodesMessageDescribeReservedNodesPaginateTypeDef,
    DescribeReservedNodesMessageRequestTypeDef,
    DescribeResizeMessageRequestTypeDef,
    DescribeScheduledActionsMessageDescribeScheduledActionsPaginateTypeDef,
    DescribeScheduledActionsMessageRequestTypeDef,
    DescribeSnapshotCopyGrantsMessageDescribeSnapshotCopyGrantsPaginateTypeDef,
    DescribeSnapshotCopyGrantsMessageRequestTypeDef,
    DescribeSnapshotSchedulesMessageDescribeSnapshotSchedulesPaginateTypeDef,
    DescribeSnapshotSchedulesMessageRequestTypeDef,
    DescribeSnapshotSchedulesOutputMessageTypeDef,
    DescribeTableRestoreStatusMessageDescribeTableRestoreStatusPaginateTypeDef,
    DescribeTableRestoreStatusMessageRequestTypeDef,
    DescribeTagsMessageDescribeTagsPaginateTypeDef,
    DescribeTagsMessageRequestTypeDef,
    DescribeUsageLimitsMessageDescribeUsageLimitsPaginateTypeDef,
    DescribeUsageLimitsMessageRequestTypeDef,
    DisableLoggingMessageRequestTypeDef,
    DisableSnapshotCopyMessageRequestTypeDef,
    DisableSnapshotCopyResultTypeDef,
    DisassociateDataShareConsumerMessageRequestTypeDef,
    EC2SecurityGroupTypeDef,
    ElasticIpStatusTypeDef,
    EnableLoggingMessageRequestTypeDef,
    EnableSnapshotCopyMessageRequestTypeDef,
    EnableSnapshotCopyResultTypeDef,
    EndpointAccessListTypeDef,
    EndpointAccessResponseMetadataTypeDef,
    EndpointAccessTypeDef,
    EndpointAuthorizationListTypeDef,
    EndpointAuthorizationResponseMetadataTypeDef,
    EndpointAuthorizationTypeDef,
    EndpointTypeDef,
    EventCategoriesMapTypeDef,
    EventCategoriesMessageTypeDef,
    EventInfoMapTypeDef,
    EventSubscriptionTypeDef,
    EventSubscriptionsMessageTypeDef,
    EventTypeDef,
    EventsMessageTypeDef,
    GetClusterCredentialsMessageRequestTypeDef,
    GetReservedNodeExchangeConfigurationOptionsInputMessageGetReservedNodeExchangeConfigurationOptionsPaginateTypeDef,
    GetReservedNodeExchangeConfigurationOptionsInputMessageRequestTypeDef,
    GetReservedNodeExchangeConfigurationOptionsOutputMessageTypeDef,
    GetReservedNodeExchangeOfferingsInputMessageGetReservedNodeExchangeOfferingsPaginateTypeDef,
    GetReservedNodeExchangeOfferingsInputMessageRequestTypeDef,
    GetReservedNodeExchangeOfferingsOutputMessageTypeDef,
    HsmClientCertificateMessageTypeDef,
    HsmClientCertificateTypeDef,
    HsmConfigurationMessageTypeDef,
    HsmConfigurationTypeDef,
    HsmStatusTypeDef,
    IPRangeTypeDef,
    LoggingStatusTypeDef,
    MaintenanceTrackTypeDef,
    ModifyAquaInputMessageRequestTypeDef,
    ModifyAquaOutputMessageTypeDef,
    ModifyAuthenticationProfileMessageRequestTypeDef,
    ModifyAuthenticationProfileResultTypeDef,
    ModifyClusterDbRevisionMessageRequestTypeDef,
    ModifyClusterDbRevisionResultTypeDef,
    ModifyClusterIamRolesMessageRequestTypeDef,
    ModifyClusterIamRolesResultTypeDef,
    ModifyClusterMaintenanceMessageRequestTypeDef,
    ModifyClusterMaintenanceResultTypeDef,
    ModifyClusterMessageRequestTypeDef,
    ModifyClusterParameterGroupMessageRequestTypeDef,
    ModifyClusterResultTypeDef,
    ModifyClusterSnapshotMessageRequestTypeDef,
    ModifyClusterSnapshotResultTypeDef,
    ModifyClusterSnapshotScheduleMessageRequestTypeDef,
    ModifyClusterSubnetGroupMessageRequestTypeDef,
    ModifyClusterSubnetGroupResultTypeDef,
    ModifyEndpointAccessMessageRequestTypeDef,
    ModifyEventSubscriptionMessageRequestTypeDef,
    ModifyEventSubscriptionResultTypeDef,
    ModifyScheduledActionMessageRequestTypeDef,
    ModifySnapshotCopyRetentionPeriodMessageRequestTypeDef,
    ModifySnapshotCopyRetentionPeriodResultTypeDef,
    ModifySnapshotScheduleMessageRequestTypeDef,
    ModifyUsageLimitMessageRequestTypeDef,
    NetworkInterfaceTypeDef,
    NodeConfigurationOptionTypeDef,
    NodeConfigurationOptionsFilterTypeDef,
    NodeConfigurationOptionsMessageTypeDef,
    OrderableClusterOptionTypeDef,
    OrderableClusterOptionsMessageTypeDef,
    PaginatorConfigTypeDef,
    ParameterTypeDef,
    PartnerIntegrationInfoTypeDef,
    PartnerIntegrationInputMessageRequestTypeDef,
    PartnerIntegrationOutputMessageTypeDef,
    PauseClusterMessageRequestTypeDef,
    PauseClusterMessageTypeDef,
    PauseClusterResultTypeDef,
    PendingModifiedValuesTypeDef,
    PurchaseReservedNodeOfferingMessageRequestTypeDef,
    PurchaseReservedNodeOfferingResultTypeDef,
    RebootClusterMessageRequestTypeDef,
    RebootClusterResultTypeDef,
    RecurringChargeTypeDef,
    RejectDataShareMessageRequestTypeDef,
    ReservedNodeConfigurationOptionTypeDef,
    ReservedNodeExchangeStatusTypeDef,
    ReservedNodeOfferingTypeDef,
    ReservedNodeOfferingsMessageTypeDef,
    ReservedNodeTypeDef,
    ReservedNodesMessageTypeDef,
    ResetClusterParameterGroupMessageRequestTypeDef,
    ResizeClusterMessageRequestTypeDef,
    ResizeClusterMessageTypeDef,
    ResizeClusterResultTypeDef,
    ResizeInfoTypeDef,
    ResizeProgressMessageTypeDef,
    ResponseMetadataTypeDef,
    RestoreFromClusterSnapshotMessageRequestTypeDef,
    RestoreFromClusterSnapshotResultTypeDef,
    RestoreStatusTypeDef,
    RestoreTableFromClusterSnapshotMessageRequestTypeDef,
    RestoreTableFromClusterSnapshotResultTypeDef,
    ResumeClusterMessageRequestTypeDef,
    ResumeClusterMessageTypeDef,
    ResumeClusterResultTypeDef,
    RevisionTargetTypeDef,
    RevokeClusterSecurityGroupIngressMessageRequestTypeDef,
    RevokeClusterSecurityGroupIngressResultTypeDef,
    RevokeEndpointAccessMessageRequestTypeDef,
    RevokeSnapshotAccessMessageRequestTypeDef,
    RevokeSnapshotAccessResultTypeDef,
    RotateEncryptionKeyMessageRequestTypeDef,
    RotateEncryptionKeyResultTypeDef,
    ScheduledActionFilterTypeDef,
    ScheduledActionResponseMetadataTypeDef,
    ScheduledActionTypeDef,
    ScheduledActionTypeTypeDef,
    ScheduledActionsMessageTypeDef,
    SnapshotCopyGrantMessageTypeDef,
    SnapshotCopyGrantTypeDef,
    SnapshotErrorMessageTypeDef,
    SnapshotMessageTypeDef,
    SnapshotScheduleResponseMetadataTypeDef,
    SnapshotScheduleTypeDef,
    SnapshotSortingEntityTypeDef,
    SnapshotTypeDef,
    SubnetTypeDef,
    SupportedOperationTypeDef,
    SupportedPlatformTypeDef,
    TableRestoreStatusMessageTypeDef,
    TableRestoreStatusTypeDef,
    TagTypeDef,
    TaggedResourceListMessageTypeDef,
    TaggedResourceTypeDef,
    TrackListMessageTypeDef,
    UpdatePartnerStatusInputMessageRequestTypeDef,
    UpdateTargetTypeDef,
    UsageLimitListTypeDef,
    UsageLimitResponseMetadataTypeDef,
    UsageLimitTypeDef,
    VpcEndpointTypeDef,
    VpcSecurityGroupMembershipTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AcceptReservedNodeExchangeInputMessageRequestTypeDef:
    return {
      ...
    }
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-redshift` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_redshift/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
